#
#  controller.py
#  Erwinia
#
#  Created by Alex Rubin on 4/29/09.
#  Copyright (c) 2009 Alex Rubin. All rights reserved.
#

from objc import YES, NO, IBAction, IBOutlet
from Foundation import *
from AppKit import *
from PyObjCTools import AppHelper
import os
from os import path
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from SocketServer import ThreadingMixIn
import threading
from threading import Thread
import socket
import urllib
import math

fileList = []
chunkSize = 1024
port = 8080

class ErwiniaHandler(BaseHTTPRequestHandler):
	def do_GET(self):
		if self.path == "/":
			self.send_response(200)
			self.send_header("Content-type", "text/html")
			self.end_headers()
			global fileList
			self.wfile.write("<strong>Files:</strong><br />")
			files = False
			for x in fileList:
				if x["type"] == "File":
					files = True
					if os.path.getsize(x["path"]) < (1024 * 1024):
						self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a> (Size: " + str(int(os.path.getsize(x["path"]) / 1024.0)) + " KB)<br />")
					else:
						self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a> (Size: " + str(int(os.path.getsize(x["path"]) / (1024.0 * 1024.0))) + " MB)<br />")
			if files is False:
				self.wfile.write("No files!<br />")
			folders = False
			self.wfile.write("<br /><strong>Folders:</strong><br />")
			for x in fileList:
				if x["type"] == "Folder":
					folders = True
					self.wfile.write("<a href=\"" + x["name"] + "\">" + x["name"] + "</a><br />")
			if folders is False:
				self.wfile.write("No folders!<br />")
			return
		else:
			for x in fileList:
				if urllib.unquote(self.path[1:]).split("/")[0] == x["name"]:
					if not os.path.exists(x["path"]):
						self.send_error(404, "File/folder not found")
						return
					if x["type"] == "File":
						NSLog("File request from " + self.client_address[0] + ": " + x["name"])
						self.send_response(200)
						self.send_header("Content-disposition", "attachment; name=" + x["name"])
						self.send_header("Content-length", os.path.getsize(x["path"]))
						self.end_headers()
						file = open(x["path"], "r")
						global chunkSize
						while True:
							chunk = file.read(chunkSize)
							if chunk == "":
								break
							else:
								self.wfile.write(chunk)
						file.close()
						return
					else:
						folder = ""
						path = urllib.unquote(self.path[1:]).split("/")[1:]
						for dir in path:
							if dir == ".." or dir == "":
								self.send_error(403, "Invalid directory")
								return
							else:
								folder += "/" + dir
						folder = folder.rstrip("/")
						if not os.path.exists(x["path"] + folder):
							self.send_error(404, "File/folder not found")
							return
						if os.path.isfile(x["path"] + folder):
							NSLog("File request from " + self.client_address[0] + ": " + x["name"] + folder)
							self.send_response(200)
							self.send_header("Content-disposition", "attachment; name=" + os.path.basename(x["path"] + folder))
							self.send_header("Content-length", os.path.getsize(x["path"] + folder))
							self.end_headers()
							file = open(x["path"] + folder, "r")
							global chunkSize
							while True:
								chunk = file.read(chunkSize)
								if chunk == "":
									break
								else:
									self.wfile.write(chunk)
							file.close()
							return
						else:
							NSLog("Folder request from " + self.client_address[0] + ": " + x["name"] + folder)
							self.send_response(200)
							self.end_headers()
							self.wfile.write("<strong>File listing for " + x["name"] + folder + ":</strong><br />")
							if not folder == "":
								self.wfile.write("<a href=\"/" + x["name"] + folder.rsplit("/", 1)[0] + "\">Go up a directory</a><br />")
							self.wfile.write("<a href=\"/\">Back to index</a><br /><br />")
							files = os.listdir(x["path"] + folder)
							if len(files) == 0:
								self.wfile.write("No files/folders!")
								return
							for file in files:
								if os.path.isfile(x["path"] + folder + "/" + file):
									if os.path.getsize(x["path"]) < (1024 * 1024):
										self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Size: " + str(int(os.path.getsize(x["path"] + folder + "/" + file) / 1024.0)) + " KB)<br />")
									else:
										self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Size: " + str(int(os.path.getsize(x["path"] + folder + "/" + file) / (1024.0 * 1024.0))) + " MB)<br />")
								else:
									self.wfile.write("<a href=\"/" + x["name"] + folder + "/" + file + "\">" + file + "</a> (Directory)<br />")
							return
			self.send_error(404, "File/folder not found")
			return

class ThreadedHTTPServer(ThreadingMixIn, HTTPServer):
	pass

class MainServer(Thread):
	def __init__(self):
		Thread.__init__(self)
	def run(self):
		global port
		threadserver = ThreadedHTTPServer(("", port), ErwiniaHandler)
		NSLog("Erwinia HTTP server starter on port " + str(port))
		threadserver.serve_forever()

class controller(NSWindowController):
	
	tableView = IBOutlet()
	arrayController = IBOutlet()
	hostedFiles = []
	
	def awakeFromNib(self):
		server = MainServer()
		server.start()
		
	@IBAction
	def addButton_(self, sender):
		panel = NSOpenPanel.openPanel()
		panel.setCanChooseDirectories_(YES)
		panel.setAllowsMultipleSelection_(NO)
		panel.beginSheetForDirectory_file_modalForWindow_modalDelegate_didEndSelector_contextInfo_(os.getcwd(), None, NSApp().mainWindow(), self, 'openPanelDidEnd:panel:returnCode:contextInfo:', 0)
	
	@AppHelper.endSheetMethod
	def openPanelDidEnd_panel_returnCode_contextInfo_(self, panel, returnCode, contextInfo):
		if returnCode:
			if os.path.isfile(panel.filenames()[0]):
				type = "File"
			else:
				type = "Folder"
			for x in self.hostedFiles:
				if x["name"] == os.path.basename(panel.filenames()[0]):
					alert = NSAlert.alloc().init()
					alert.setMessageText_("Duplicate file/folder")
					alert.setInformativeText_("There is already a file or folder with the name \"" + os.path.basename(panel.filenames()[0]) + "\"!")
					alert.setAlertStyle_(NSWarningAlertStyle)
					alert.runModal()
					return
			NSLog("Added " + type.lower() + ": " + os.path.basename(panel.filenames()[0]))
			self.hostedFiles += [NSDictionary.dictionaryWithDictionary_({"name": os.path.basename(panel.filenames()[0]), "type": type, "url": "http://" + socket.gethostbyname(socket.gethostname()) + ":" + str(port) + "/" + os.path.basename(panel.filenames()[0]), "path": panel.filenames()[0]})]
			self.arrayController.rearrangeObjects()
			global fileList
			fileList = self.hostedFiles
		else:
			pass
	
	@IBAction
	def removeButton_(self, sender):
		NSLog("Removed " + self.hostedFiles[self.tableView.selectedRow()]["type"].lower + ": " + self.hostedFiles[self.tableView.selectedRow()]["name"])
		self.arrayController.rearrangeObjects()
		global fileList
		fileList = self.hostedFiles